unit Alterac;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, DBGrids, DBTables, Grids, ExtCtrls,
  Buttons, DBLookup, Mask,dialogs;

type
  TAlteracForm = class(TForm)
    DBGrid1: TDBGrid;
    DBNavigator: TDBNavigator;
    Panel1: TPanel;
    AlteracSrc: TDataSource;
    Panel2: TPanel;
    AlteracTbl: TTable;
    AuxFilTbl: TTable;
    AuxFilSrc: TDataSource;
    AlteracTblNumero: TIntegerField;
    AlteracTblData: TDateField;
    AlteracTblCargo: TSmallintField;
    AlteracTblSalario: TCurrencyField;
    AlteracTblObs: TStringField;
    AuxFilTblNumero: TIntegerField;
    CargoTbl: TTable;
    CargoSrc: TDataSource;
    DBText1: TDBText;
    Label1: TLabel;
    CargoTblCargo: TSmallintField;
    CargoTblDesc: TStringField;
    Alterac2Tbl: TTable;
    Alterac2Src: TDataSource;
    Cargo2Tbl: TTable;
    Cargo2Src: TDataSource;
    DBEdit1: TDBEdit;
    DBLookupCombo1: TDBLookupCombo;
    DBEdit2: TDBEdit;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    DBMemo1: TDBMemo;
    BitBtn2: TBitBtn;
    Alterac2TblNumero: TIntegerField;
    Alterac2TblData: TDateField;
    Alterac2TblCargo: TSmallintField;
    Alterac2TblSalario: TCurrencyField;
    Alterac2TblObs: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AlteracTblBeforePost(DataSet: TDataset);
    procedure BitBtn2Click(Sender: TObject);
    procedure Alterac2TblBeforePost(DataSet: TDataset);
    procedure Alterac2TblNewRecord(DataSet: TDataset);
    procedure BitBtn1Click(Sender: TObject);
    procedure AlteracTblBeforeInsert(DataSet: TDataset);
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  AlteracForm: TAlteracForm;

implementation

{$R *.DFM}

procedure TAlteracForm.FormCreate(Sender: TObject);
begin
AlteracTbl.DisableControls;
CargoTbl.DisableControls;
Try
AuxFilTbl.Open;
auxFilTbl.First;
AlteracTbl.Open;
AlteracTbl.First;
AlteracTbl.SetRangeStart;
AlteracTblNumero.value:=AuxFilTblNumero.value;
AlteracTbl.SetRangeEnd;
AlteracTblNumero.value:=AuxFilTblNumero.value;
AlteracTbl.KeyFieldCount := 1;
AlteracTbl.ApplyRange;
cargoTbl.Open;
finally
AlteracTbl.EnableControls;
CargoTbl.EnableControls;
end;
end;


procedure TAlteracForm.FormDeactivate(Sender: TObject);
begin
AlteracForm.Close;

end;

procedure TAlteracForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
AlteracTbl.Close;
AuxFilTbl.Close;
cargoTbl.Close;
Alterac2Tbl.Close;
Cargo2Tbl.Close;
AlteracForm.Release;
end;

procedure TAlteracForm.AlteracTblBeforePost(DataSet: TDataset);
begin
AlteracTblNumero.value:=AuxFilTblNumero.value;
end;

procedure TAlteracForm.BitBtn2Click(Sender: TObject);
begin
Alterac2Tbl.disablecontrols;
cargo2tbl.disablecontrols;
try
alterac2tbl.open;
cargo2tbl.open;
alterac2tbl.insert;

finally
Alterac2Tbl.enablecontrols;
cargo2tbl.enablecontrols;
Dbedit1.SetFocus;
end;
end;

procedure TAlteracForm.Alterac2TblBeforePost(DataSet: TDataset);
begin
Alterac2TblNumero.value:=AuxFilTblNumero.value;
end;

procedure TAlteracForm.Alterac2TblNewRecord(DataSet: TDataset);
begin
Alterac2TblData.value:=now;
end;

procedure TAlteracForm.BitBtn1Click(Sender: TObject);
begin
if Dbedit1.text = '' then
begin
MessageDlg('Deve-se preencher o campo de data', mterror, [mbOK], 0);
abort;
end;

if Dbedit2.text = '' then
begin
MessageDlg('Deve-se preencher o campo de Salrio', mterror, [mbOK], 0);
abort;
end;

if DBlookUpcombo1.text = '' then
begin
MessageDlg('Deve-se preencher o campo de cargo', mterror, [mbOK], 0);
abort;
end;

{If Alterac2Tbl.Findkey([AuxFilTblNumero.value,Alterac2tblData.value]) then
begin
MessageDlg('J foi definido um cargo/salrio com a mesma data !'
+ 'Modifique a data !', mterror, [mbOK], 0);
abort;
end;  }


Alterac2Tbl.Post;
Alterac2Tbl.Close;
Cargo2Tbl.Close;

begin
AlteracTbl.DisableControls;
CargoTbl.DisableControls;
Try
auxFilTbl.First;
AlteracTbl.First;
AlteracTbl.SetRangeStart;
AlteracTblNumero.value:=AuxFilTblNumero.value;
AlteracTbl.SetRangeEnd;
AlteracTblNumero.value:=AuxFilTblNumero.value;
AlteracTbl.KeyFieldCount := 1;
AlteracTbl.ApplyRange;
finally
AlteracTbl.EnableControls;
CargoTbl.EnableControls;
end;
end;
end;

procedure TAlteracForm.AlteracTblBeforeInsert(DataSet: TDataset);
begin
MessageDlg('Utilize o boto NOVO para novos registros', mterror, [mbOK], 0);
abort;
end;

procedure TAlteracForm.DBEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9','/']) then
          Key := #0;
end;

end.
