{ Form Template - Source and Destination Choices Lists }
unit Imphol;

interface

uses SysUtils, WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, DBCtrls, DB, DBTables, Mask,dialogs,ExtCtrls, Messages, Report;


type
  TImpHolForm = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    SrcList: TListBox;
    DstList: TListBox;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    Label1: TLabel;
    ComboBox1: TComboBox;
    MaskEdit1: TMaskEdit;
    Label2: TLabel;
    CadastroTbl: TTable;
    Cadastro2Src: TDataSource;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    CadastroTblNumero: TIntegerField;
    CadastroTblDataDesl: TDateField;
    Cadastro2Tbl: TTable;
    MesImpTbl: TTable;
    MesImpTblNumero: TIntegerField;
    MesImpTblMes: TSmallintField;
    MesImpTblAno: TIntegerField;
    Report1: TReport;
    EventosTbl: TTable;
    EventosTblCodigo: TIntegerField;
    EventosTblDesc: TStringField;
    Report2: TReport;
    Query1: TQuery;
    Query1Numero: TIntegerField;
    Query1DataDesl: TDateField;
    Report3: TReport;
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    procedure MaskEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure SrcListClick(Sender: TObject);
    procedure DstListClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure SrcListDblClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ImpHolForm: TImpHolForm;

implementation

{$R *.DFM}

procedure TImpHolForm.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
end;

procedure TImpHolForm.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
end;

procedure TImpHolForm.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I], 
      SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TImpHolForm.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;

procedure TImpHolForm.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

procedure TImpHolForm.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExAllBtn.Enabled := not DstEmpty;
end;

function TImpHolForm.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TImpHolForm.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TImpHolForm.MaskEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9']) then
          Key := #0;
end;

procedure TImpHolForm.FormCreate(Sender: TObject);
begin
Query1.DisableControls;
Try
MesImpTbl.Open;
MesImpTbl.First;
While not MesImpTbl.EOF do MesImpTbl.Delete;
Query1.Close;
Query1.SQL.Clear;
Query1.SQL.Add('Select numero,datadesl from "fcadast.db" order by numero');
Query1.Open;
While not Query1.EOF do
begin
if Query1DataDesl.asstring = '' then
begin
SrcList.Items.Add(Query1Numero.asstring);
Query1.Next;
end
else Query1.Next;
end;
finally
Query1.EnableControls;
end;

end;


procedure TImpHolForm.SrcListClick(Sender: TObject);
var
  Index: Integer;
begin

  Cadastro2Tbl.DisableControls;
  DBEdit1.Clear;
  Try
  Cadastro2Tbl.Open;
  Index := GetFirstSelection(SrcList);
  Cadastro2Tbl.SetKey;
  Cadastro2Tbl.Fields[0].AsString:= SrcList.Items[Index];
  Cadastro2Tbl.GotoKey;
  Finally
  Cadastro2Tbl.EnableControls;

  end;
end;

procedure TImpHolForm.DstListClick(Sender: TObject);
var
  Index: Integer;
begin

  Cadastro2Tbl.DisableControls;
  DBEdit1.Clear;
  Try
  Cadastro2Tbl.Open;
  Index := GetFirstSelection(DstList);
  Cadastro2Tbl.SetKey;
  Cadastro2Tbl.Fields[0].AsString:= DstList.Items[Index];
  Cadastro2Tbl.GotoKey;
  Finally
  Cadastro2Tbl.EnableControls;

  end;
end;

procedure TImpHolForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
MesImpTbl.Open;
MesImpTbl.First;
While not MesImpTbl.EOF do MesImpTbl.Delete;
{deletar os eventos 198 e 199 - so servem para o Rpt Smith }
EventosTbl.Open;
EventosTbl.edit;
If EventosTbl.Findkey([198]) then
begin
EventosTbl.GoToKey;
EventosTbl.delete;
end;

If EventosTbl.Findkey([199]) then
begin
EventosTbl.GoToKey;
EventosTbl.delete;
end;
{finalizacao da deleo }
EventosTbl.Close;
Query1.Close;
Cadastro2Tbl.Close;
MesImpTbl.Close;
ImpHolForm.Release;
end;

procedure TImpHolForm.FormDeactivate(Sender: TObject);
begin
ImpHolForm.Close;
end;

procedure TImpHolForm.SrcListDblClick(Sender: TObject);
begin
IncludeBtnClick(Sender);
end;

procedure TImpHolForm.CancelBtnClick(Sender: TObject);
begin
MaskEdit1.Text:='';
ExcAllBtnClick(Sender);
end;

procedure TImpHolForm.OKBtnClick(Sender: TObject);
var mes,ano,index : Integer;
begin

If ComboBox1.text = '' then
begin
MessageDlg(' necessrio escolher o ms'
  ,mterror,[mbOK], 0);
  abort;
end;

If maskEdit1.Text = '' then
begin
MessageDlg(' necessrio especificar o ano'
  ,mterror,[mbOK], 0);
  abort;
end;

If ComboBox1.ItemIndex = 0 then  mes:=1; ;
If ComboBox1.ItemIndex = 1 then  mes:=2;
If ComboBox1.ItemIndex = 2 then  mes:=3; ;
If ComboBox1.ItemIndex = 3 then  mes:=4;
If ComboBox1.ItemIndex = 4 then  mes:=5; ;
If ComboBox1.ItemIndex = 5 then  mes:=6;
If ComboBox1.ItemIndex = 6 then  mes:=7; ;
If ComboBox1.ItemIndex = 7 then  mes:=8; ;
If ComboBox1.ItemIndex = 8 then  mes:=9;
If ComboBox1.ItemIndex = 9 then  mes:=10; ;
If ComboBox1.ItemIndex = 10 then  mes:=11;
If ComboBox1.ItemIndex = 11 then  mes:=12;
If ComboBox1.ItemIndex = 12 then  mes:=13;
If ComboBox1.ItemIndex = 13 then  mes:=14;

ano :=StrToInt(MaskEdit1.Text);

MesImpTbl.Open; {arquivo aux para o Report Smith}
for Index := 0 to DstList.Items.Count - 1 do
begin
MesImpTbl.Insert;
MesImpTblNumero.value:=StrToInt(DstList.Items[Index]);
MesImpTblMes.value:=mes;
MesImpTblAno.value:=ano;
MesImpTbl.Post;
end;
MesImpTbl.Close;
if MessageDlg('Imprimir os Holeriths agora ? ',
mtwarning,mbOKCancel,0) = mrOK then
begin {kkk}
 MessageDlg('Selecione a Impressora Epson FX-100 ! '
  ,mtinformation,[mbOK], 0);

{ Rotina abaixo necessria sempre que formos rodar os holeriths .
Ela adiciona os eventos 198- INSS e 199 - Ajuste do mes anterior
na tabela  Eventos.db com a finalidade do Report Smith mostrar esses
itens como eventos  - Apos a impresso esses eventos tem de ser deletados}
EventosTbl.Open;

EventosTbl.Insert;
EventosTblCodigo.value:=198;
EventosTblDesc.value:='INSS';
EventosTbl.Post;

EventosTbl.Insert;
EventosTblCodigo.value:=199;
EventosTblDesc.value:='Arred.Anterior';
EventosTbl.Post;

{final da rotina }
If mes = 13 then
begin
Report2.InitialValues.Add('@Mes=<'+InttoStr(mes)+'>');
Report2.InitialValues.Add('@Ano=<'+IntToStr(ano)+'>');
Report2.Preview := False;
Report2.Run;
end;

If mes = 14 then{holerith especial para a seg parc do 13o. -
O INSS nao entra na conta do FGTS }
begin
Report3.InitialValues.Add('@Mes=<'+InttoStr(mes)+'>');
Report3.InitialValues.Add('@Ano=<'+IntToStr(ano)+'>');
Report3.Preview := False;
Report3.Run;
end
else
begin
Report1.InitialValues.Add('@Mes=<'+InttoStr(mes)+'>');
Report1.InitialValues.Add('@Ano=<'+IntToStr(ano)+'>');
Report1.Preview := False;
Report1.Run;
end;
end; {kkk}
MessageDlg('Clique aps a impresso !'
  ,mtinformation,[mbOK], 0);

SrcList.Items.Clear;
DstList.Items.Clear;
ComboBox1.Text:='';
MaskEdit1.Text:='';
{deletar os registros 198 e 199 - so servem para o Rpt Smith }
EventosTbl.Edit;
If EventosTbl.Findkey([198]) then
begin
EventosTbl.GoToKey;
EventosTbl.delete;
end;

If EventosTbl.Findkey([199]) then
begin
EventosTbl.GoToKey;
EventosTbl.delete;
end;
{finalizacao da deleo }
FormCreate(Sender);


end;

end.
